Subject: Re: [PATCH] merge-ort: make informational messages from recursive merges clearer

From: Junio C Hamano <[email-masked]>
Date: Thu, 17 Feb 2022 15:10:38 -0800

"Elijah Newren via GitGitGadget" <[email-masked]> writes:

> From: Elijah Newren <[email-masked]>
>
> This is another simple change with a long explanation...
>
> merge-recursive and merge-ort are both based on the same recursive idea:
> if there is more than one merge base, merge the merge bases (which may
> require first merging the merge bases of the merges bases, etc.).  The
> depth of the inner merge is recorded via a variable called "call_depth",
> which we'll bring up again later.  Naturally, the inner merges
> themselves can have conflicts and various messages generated about those
> files.
>
> merge-recursive immediately prints to stdout as it goes, at the risk of
> printing multiple conflict notices for the same path separated far apart
> from each other with many intervenining conflict notices for other paths
> between them.  And this is true even if there are no inner merges
> involved.  An example of this was given in [1] and apparently caused
> some confusion:
>
>     CONFLICT (rename/add): Rename A->B in HEAD. B added in otherbranch
>     ...dozens of conflicts for OTHER paths...
>     CONFLICT (content): Merge conflicts in B
>
> In contrast, merge-ort collects messages and stores them by path so that
> it can print them grouped by path.  Thus, the same case handled by
> merge-ort would have output of the form:
>
>     CONFLICT (rename/add): Rename A->B in HEAD. B added in otherbranch
>     CONFLICT (content): Merge conflicts in B
>     ...dozens of conflicts for OTHER paths...
>
> This is generally helpful, but does make a separate bug more
> problematic.  In particular, while merge-recursive might report the
> following for a recursive merge:
>
>       Auto-merging dir.c
>       Auto-merging midx.c
>       CONFLICT (content): Merge conflict in midx.c
>     Auto-merging diff.c
>     Auto-merging dir.c
>     CONFLICT (content): Merge conflict in dir.c
>
> merge-ort would instead report:
>
>     Auto-merging diff.c
>     Auto-merging dir.c
>     Auto-merging dir.c
>     CONFLICT (content): Merge conflict in dir.c
>     Auto-merging midx.c
>     CONFLICT (content): Merge conflict in midx.c
>
> The fact that messages for the same file are together is probably
> helpful in general, but with the indentation missing for the inner
> merge it unfortunately serves to confuse.  This probably would lead
> users to wonder:
>
>   * Why is Git reporting that "dir.c" is being merged twice?
>   * If midx.c has conflicts, why do I not see any when I open up the
>     file and why are no conflicts shown in the index?
>
> Fix this output confusion by changing the output to clearly
> differentiate the messages for outer merges from the ones for inner
> merges, changing the above output from merge-ort to:
>
>     Auto-merging diff.c
>       From inner merge:  Auto-merging dir.c
>     Auto-merging dir.c
>     CONFLICT (content): Merge conflict in dir.c
>       From inner merge:  Auto-merging midx.c
>       From inner merge:  CONFLICT (content): Merge conflict in midx.c
>
> (Note: the number of spaces after the 'From inner merge:' is
> 2*call_depth).

So "From inner merge: " label is what we get extra, compared to the
recursive one that just gives deeper leading-space indentation?

> One other thing to note here, that I didn't notice until typing up this
> commit message, is that merge-recursive does not print any messages from
> the inner merges by default; the extra verbosity has to be requested.
> merge-ort currently has no verbosity controls and always prints these.
> We may also want to change that, but for now, just make the output
> clearer with these extra markings and indentation.

Yup, I found that the messages on inner conflicts, especially when
they "cancel out" at the outer merge, are mostly noise that carries
very little useful information (by being noisy, the user gets a sense
of how complex the histories being merged are).  Reducing the default
messaging level would probably be a good idea.

> Published-As: https://github.com/gitgitgadget/git/releases/tag/pr-1121%2Fnewren%2Fmerge-ort-clearer-v1
> Fetch-It-Via: git fetch https://github.com/gitgitgadget/git pr-1121/newren/merge-ort-clearer-v1
> Pull-Request: https://github.com/gitgitgadget/git/pull/1121
>
>  merge-ort.c | 5 +++++
>  1 file changed, 5 insertions(+)
>
> diff --git a/merge-ort.c b/merge-ort.c
> index d85b1cd99e9..55decb2587e 100644
> --- a/merge-ort.c
> +++ b/merge-ort.c
> @@ -651,6 +651,11 @@ static void path_msg(struct merge_options *opt,
>  	dest = (opt->record_conflict_msgs_as_headers ? &tmp : sb);
>  
>  	va_start(ap, fmt);
> +	if (opt->priv->call_depth) {
> +		strbuf_addchars(dest, ' ', 2);
> +		strbuf_addstr(dest, "From inner merge:");
> +		strbuf_addchars(dest, ' ', opt->priv->call_depth * 2);

I am unsure if the long label adds much value, but I am perfectly OK
tostart from more verbose and see if people complain (or not).  This
is for human consumption and not meant to be machine parseable so we
can iterate.

Will queue.  Thanks.